Skip to main content

Graph Question - Medium Level - Question 2

 2192. All Ancestors of a Node in a Directed Acyclic Graph

You are given a positive integer n representing the number of nodes of a Directed Acyclic Graph (DAG). The nodes are numbered from 0 to n - 1 (inclusive).

You are also given a 2D integer array edges, where edges[i] = [fromi, toi] denotes that there is a unidirectional edge from fromi to toi in the graph.

Return a list answer, where answer[i] is the list of ancestors of the ith node, sorted in ascending order.

A node u is an ancestor of another node v if u can reach v via a set of edges.


Constraints:

1 <= n <= 1000

0 <= edges.length <= min(2000, n * (n - 1) / 2)

edges[i].length == 2

0 <= fromi, toi <= n - 1

fromi != toi

There are no duplicate edges.

The graph is directed and acyclic.


Analysis:


This question can be solved by constructing a graph by the edges information.

Since this question asks for the parents information, we can create a graph storing the direct parents notes. 

After having the graph, we can do a top-down dfs, to search through each sub-tree, and merge the results from all sub-trees into one vector which are the all the ancestors of the current node.

To reduce the redundant searching, a visited vector can be used to record the visiting status. Once visited once, the status will be labeled as 1, then all the following visits can return the previous result directly without searching again.

So the method can be viewed as dfs + dp in general.


Time complexity: for each node, we perform one dfs. For each dfs, we can reuse the results from previous dfs with the visited vector (dp), so the averaged time complexity for this step is O(N), where N is the number of nodes. But there is still another step in each dfs, merging ancestors into one vector, which is O(Nlog(N)) in average. So the overall time complexity is O(N^2*log(N)).

The space time complexity is O(N^2).


See the code below:


class Solution {
public:
    vector<vector<int>> getAncestors(int n, vector<vector<int>>& edges) {
        vector<vector<int>> res(n), g(n);
        vector<int> visited(n, 0);
        for(auto &a : edges) g[a[1]].push_back(a[0]);
        for(int i=0; i<n; ++i) {
            dfs(i, g, visited, res);
        }
        return res;
    }
private:
    vector<int> dfs(int i, vector<vector<int>>& g, vector<int>& vit, vector<vector<int>>& res) {
        if(vit[i]) {
            return res[i];
        }
        vit[i] = 1;
        vector<int> ret;
        for(auto &a : g[i]) {
            vector<int> one = dfs(a, g, vit, res);
            for(auto &b : one) ret.push_back(b);
            ret.push_back(a);
        }
        sort(ret.begin(), ret.end());
        vector<int> copy;
        for(auto &a : ret) {
            if(copy.empty() || copy.back() != a) copy.push_back(a);
        }
        return res[i] = copy;
    }
};


Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once. We

Binary Search - Hard Level - Question 3

Binary Search - Hard Level - Question 3 878. Nth Magical Number A positive integer is magical if it is divisible by either a or b. Given the three integers n, a, and b, return the nth magical number. Since the answer may be very large, return it modulo 10^9 + 7. Analysis: Let us consider some examples first. Example 1, a = 4, b = 2. If b is dividable by a, then all the numbers which is dividable by a should be dividable by b as well. So the nth magical number should be n*b; Example 2, a = 3, b = 2. The multiples of 2 are: 2, 4, 6, 8, 10, 12, ... The multiple of 3 are: 3, 6, 9, 12, ... So the overlap is related to the minimum common multiple between a and b, and we need to remove the overlap which is double-counted. So now, we make some conclusions: 1. the upper bound of the nth magical number should be n*b, where a is the smaller one (or b <= a); 2. there are n*b/a magical numbers smaller than n*b; 3. there are n*b/(minimum common multiple) overlaps. Thus, the overall count is: n +

Recursion - Example

Recursion - Example Leetcode 231  Power of Two Given an integer n, return true if it is a power of two. Otherwise, return false. An integer n is a power of two, if there exists an integer x such that n == 2^x Constraints: -2^31 <= n <= 2^31 - 1 Analysis: One way is to think about this question recursively: if n%2 == 1, then n must not be power of 2; if not, then we just need to consider whether (n/2) is a power of 2 or not. This is exactly the "same question with a smaller size"! It is trivial to figure out the base cases: if n == 0, return false; if n == 1, return true. See the code below: class Solution { public: bool isPowerOfTwo(int n) { // base cases if(n == 0) return false; if(n == 1) return true; // converging if(n%2 == 1) return false; return isPowerOfTwo(n/2); } }; If interested, there are some other ways to solve this problem. For example, using bit manipulation, we can have the following solution: class